			title		'InitTMR0 - Initialize timer 0'
			subtitle	'Part of Lesson 20 on interrupts'
			list		b=4,c=132,n=77,x=Off

			include		Processor.inc

;------------------------------------------------------------------------
;**
;	InitTmr0
;
;	This function initializes the timer for use by the Lesson 20
;	exercises.
;
;**
;	WB8RCR - 19-May-06
;	$Revision: 1.20.1.4 $ $State: Rel $ $Date: 2007-06-13 13:07:13-04 $

			global		InitTMR0

MYLIB		code
InitTMR0:
			bcf			INTCON,T0IE		; Mask timer interrupt

	; IRL, we would have simply loaded a constant, but the
	; code below makes it explicit what we are doing
			errorlevel	-302
			banksel		OPTION_REG
			bcf			OPTION_REG,T0CS	; Enable timer
			bcf			OPTION_REG,T0SE	; Use rising edge
			bcf			OPTION_REG,PSA	; Prescaler to timer
			bsf			OPTION_REG,PS2	; \
			bsf			OPTION_REG,PS1	;  >- 1:256 prescale
			bsf			OPTION_REG,PS0	; /
			banksel		PORTA
			errorlevel	+302
			return
			end
