			title		'RestCnt - Restore counter from EEPROM'
			subtitle	'Part of Lesson 20 on interrupts'
			list		b=4,c=132,n=77,x=Off

			include		Processor.inc
			include		EEPROM.inc

;------------------------------------------------------------------------
;**
;	RestCnt
;
;	Restore the counter from EEPROM
;
;**
;	WB8RCR - 23-May-06
;	$Revision: 1.20.1.4 $ $State: Rel $ $Date: 2007-06-13 13:07:13-04 $

			errorlevel	-302			; Disable bank error
			global		RestCnt
			extern		binary,LEDflg


MYLIB		code
RestCnt:
			movlw		H'0a'			; Middle LED on
			movwf		PORTB
			movwf		LEDflg
			movlw		SAVADR			; Store the EEPROM address
			movwf		EEADR			; to the address register
			banksel		EECON1
			bsf			EECON1,RD		; and command a read
			banksel		EEDATA
			movf		EEDATA,W		; Pick up the value from EEPROM
			movwf		binary			; And save it in binary
			incf		EEADR,F			; Now point to next EEPROM location
			banksel		EECON1
			bsf			EECON1,RD		; again command a read
			banksel		EEDATA
			movf		EEDATA,W		; grab the high byte
			movwf		binary+1		; and store in high byte of result
			
			movlw		H'0e'			; All LEDs off
			movwf		LEDflg
			movwf		PORTB

			return
			end
